//
//      SGXListProducts.hpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.1.1
//

/**
***	Project         : Amazon Products Viewing
***	File			: AWSListProducts.hpp	
***	Description		: List of Products, gotten from Amazon or favorite file 
**/

#ifndef __AWSLISTPRODUCTS_HPP
#define __AWSLISTPRODUCTS_HPP

#include <SophiaFramework.hpp>
#include "AWSProduct.hpp"

SFMTYPEDEFCLASS(AWSListProducts)
class AWSListProducts {
SFMSEALCOPY(AWSListProducts)

private:
	SFXAnsiString			_errmsg;			// error message
	SFXArray<AWSProductPtr> _productarray;		// list of products

public:
    AWSListProducts(Void);
    virtual		~AWSListProducts(Void);
	
	SFXAnsiString	GetErrMsg(){return _errmsg;};	
	UInt16			GetSize(){return (UInt16)_productarray.GetSize();};
	AWSProductPtr	GetProduct(UInt16 index);

	SFCError	GetFavoriteProducts(SFXPathConstRef filename, SFXAnsiString producttype);
	Void		UpdateFavoriteFile(SFXPathConstRef filename);
	SFCError	RemoveProduct(SFXAnsiStringConstRef asin);
	SFCError	RemoveAllProducts();

	SFCError	GetXMLProducts(SFXPathConstRef filename, SFXAnsiString producttype); // get product information from XML file
	SFCError	GetXMLProducts(SFXXMLElementPtr root, SFXAnsiString producttype); 
	SFCError	ParseItem(SFXXMLNodePtr node, AWSProductPtr item);
};

#endif // __AWSLISTPRODUCTS_HPP //
