//
//      AWSProduct.cpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.1.1
//

#include "pself3.hpp"
#include "AWSTabControl.hpp"
#include "AWSProduct.hpp"

//++++++++++++++++++++++++++AWSProduct class implementation+++++++++++++++++++++++++++++//

// Constructor
AWSProduct::AWSProduct() :
	_isParseItemAttributes(true),
    _isParseImageUrl(false), 
	_isParseOfferSummary(false),
    _isParseOffers(false), 
	_isParseCustomerReviews(false),
    _isParseSimilarProducts(false), 
	_isParseBrowserNodes(false),
    _isParseListmaniaLists(false),
    _imageUrl(null), _offerSummary(null), _offers(null), _customerReviews(null), 
	_similarProducts(null), _browserNodes(null), _listmaniaLists(null)
{
    return;
}

// Destructor
AWSProduct::~AWSProduct(Void)
{
	ClearData();
}

// Factory function
AWSProductPtr AWSProduct::Factory(SFXAnsiString producttype) 
{
	if(producttype == BOOK_SEARCH) 
		return	::new AWSBook();
	
	if(producttype == DVD_SEARCH) 
		return	::new AWSDvd();
	
	return null;
}

// release resource
Void AWSProduct::ClearData(Void)
{
	_title.Clear();
	_asin.Clear();

	delete _imageUrl;
	_imageUrl = null;
    
	delete _offerSummary;
	_offerSummary = null;
  
	if (_offers != null) 
	{
		SFXArray<OfferRecPtr>::Enumerator enumerator = _offers->offers.GetFirstEnumerator();
		while (enumerator.HasNext()) 
		{
			OfferRecPtr offer(enumerator.GetNext());
			delete offer;
		}
		_offers->offers.Clear();
		delete _offers;
		_offers = null;
	}
    
	if (_customerReviews != null) 
	{
		SFXArray<ReviewRecPtr>::Enumerator enumerator = _customerReviews->reviews.GetFirstEnumerator();
		while (enumerator.HasNext()) 
		{
			ReviewRecPtr review(enumerator.GetNext());
			delete review;
		}
		_customerReviews->reviews.Clear();
		delete _customerReviews;
		_customerReviews = null;
	}

	if (_similarProducts != null) 
	{
		SFXArray<SimilarProductRecPtr>::Enumerator enumerator = _similarProducts->similarProducts.GetFirstEnumerator();
		while (enumerator.HasNext()) 
		{
			SimilarProductRecPtr similarProduct(enumerator.GetNext());
			delete similarProduct;
		}
		_similarProducts->similarProducts.Clear();
		delete _similarProducts;
		_similarProducts = null;
    }
}

// helper function
SFXAnsiString AWSProduct::DecodeHtml(SFXAnsiStringConstRef string)
{
    return string.Replace("&lt;", '<').Replace("&gt;", '>').Replace("&quot;", '"').Replace("&amp;", '&');
}

// helper function
SFXDate StringToDate(SFXAnsiStringConstRef string)
{
    SFXDate ret(0);

    // YYYY/MM/DD ` YYYY/MM `gĂ悤łB
    // YYYY/MM `̎̃f[^͖̈B
    if (string.GetLength() >= 10) {
        ret.SetDate(static_cast<SInt16>(string.Substring(0, 4).AsUInt32()),
                    static_cast<SInt16>(string.Substring(5, 7).AsUInt32()),
                    static_cast<SInt16>(string.Substring(8, 10).AsUInt32()));
    }
    else if (string.GetLength() >= 7) {
        ret.SetDate(static_cast<SInt16>(string.Substring(0, 4).AsUInt32()),
                    static_cast<SInt16>(string.Substring(5, 7).AsUInt32()), 1);
    }
    return ret;
}

// Get title
SFCError AWSProduct::ParseTitle(SFXXMLNodePtr node)
{
    SFCError error(SFERR_NO_ERROR);

    if (node != null) {
        for (; node != null; node = node->GetNextSibling()) {
            if (SFXAnsiString(node->GetNodeName()) == "Title") {
                _title = DecodeHtml(node->GetText());
            }
        }
    }
    else {
        error = SFERR_FAILED;
    }
    return error;
}
// Get small image information
SFCError AWSProduct::ParseSmallImage(SFXXMLNodePtr node)
{
	SFCError error(SFERR_NO_ERROR);

	if (node == null) return SFERR_FAILED;
	
	if (_imageUrl == null) _imageUrl = new ImageUrlRec;
	if (_imageUrl == null) return SFERR_NO_MEMORY;

	for (; node != null; node = node->GetNextSibling()) 
	{
		if (SFXAnsiString(node->GetNodeName()) == "URL") 
			_imageUrl->smallImageURL = DecodeHtml(node->GetText());
		else if (SFXAnsiString(node->GetNodeName()) == "Height") 
			_imageUrl->smallImageHeight = node->GetText().AsSInt32();
		else if (SFXAnsiString(node->GetNodeName()) == "Width") 
			_imageUrl->smallImageWidth = node->GetText().AsSInt32();
	}

    return error;
}

// Get medium image information
SFCError AWSProduct::ParseMediumImage(SFXXMLNodePtr node)
{
	SFCError error(SFERR_NO_ERROR);

	if (node == null) return SFERR_FAILED;

	if (_imageUrl == null) _imageUrl = new ImageUrlRec;
	if (_imageUrl == null) return SFERR_NO_MEMORY;

	for (; node != null; node = node->GetNextSibling()) 
	{
		if (SFXAnsiString(node->GetNodeName()) == "URL") 
			_imageUrl->mediumImageURL = DecodeHtml(node->GetText());
		else if (SFXAnsiString(node->GetNodeName()) == "Height")
			 _imageUrl->mediumImageHeight = node->GetText().AsSInt32();
		else if (SFXAnsiString(node->GetNodeName()) == "Width") 
			_imageUrl->mediumImageWidth = node->GetText().AsSInt32();
	}
 
	return error;
}

// Get large image information
SFCError AWSProduct::ParseLargeImage(SFXXMLNodePtr node)
{
	SFCError error(SFERR_NO_ERROR);

	if (node == null) return SFERR_FAILED;
        
	if (_imageUrl == null) _imageUrl = new ImageUrlRec;
	if (_imageUrl == null)	return SFERR_NO_MEMORY;
	
	for (; node != null; node = node->GetNextSibling()) 
	{
		if (SFXAnsiString(node->GetNodeName()) == "URL")
			 _imageUrl->largeImageURL = DecodeHtml(node->GetText());
		 else if (SFXAnsiString(node->GetNodeName()) == "Height")
			_imageUrl->largeImageHeight = node->GetText().AsSInt32();
		 else if (SFXAnsiString(node->GetNodeName()) == "Width")
			_imageUrl->largeImageWidth = node->GetText().AsSInt32();
	}

    return error;
}

// Not yet implimented.
SFCError AWSProduct::ParseOfferSummary(SFXXMLNodePtr /*node*/){ return SFERR_NO_ERROR;}
SFCError AWSProduct::ParseOffers(SFXXMLNodePtr /*node*/){ return SFERR_NO_ERROR;}

//Get customer reviews
SFCError AWSProduct::ParseCustomerReviews(SFXXMLNodePtr node)
{
	SFCError error(SFERR_NO_ERROR);

    if (node == null) return SFERR_FAILED;

	_customerReviews = new CustomerReviewsRec;
	if (_customerReviews == null) return SFERR_NO_MEMORY;

	for (; node != null && error == SFERR_NO_ERROR; node = node->GetNextSibling()) 
	{
		if (SFXAnsiString(node->GetNodeName()) == "AverageRating")
			_customerReviews->averageRating = node->GetText().AsSInt32();
		else if (SFXAnsiString(node->GetNodeName()) == "TotalReviews")
			_customerReviews->totalReviews = node->GetText().AsSInt32();
		else if (SFXAnsiString(node->GetNodeName()) == "TotalReviewPages")
			_customerReviews->totalReviewPages = node->GetText().AsSInt32();
		else if (SFXAnsiString(node->GetNodeName()) == "Review") 
		{
			SFXXMLNodePtr node2(node->GetFirstChild());
			
			ReviewRecPtr review = new ReviewRec;
			if (review == null) return SFERR_NO_MEMORY;
			
			for (; node2 != null; node2 = node2->GetNextSibling()) 
			{
				if (SFXAnsiString(node2->GetNodeName()) == "ASIN")
					review->asin = DecodeHtml(node2->GetText());
				else if (SFXAnsiString(node2->GetNodeName()) == "Rating")
					review->rating = node2->GetText().AsSInt32();
				else if (SFXAnsiString(node2->GetNodeName()) == "HelpfulVotes")
					review->helpfulVotes = node2->GetText().AsSInt32();
				else if (SFXAnsiString(node2->GetNodeName()) == "CustomerId")
					review->customerId = DecodeHtml(node2->GetText());
				else if (SFXAnsiString(node2->GetNodeName()) == "TotalVotes")
					review->totalVotes = node2->GetText().AsSInt32();
				else if (SFXAnsiString(node2->GetNodeName()) == "Date")
					review->date = StringToDate(node2->GetText());
				else if (SFXAnsiString(node2->GetNodeName()) == "Summary")
					review->summary = DecodeHtml(node2->GetText());
				else if (SFXAnsiString(node2->GetNodeName()) == "Content")
                                review->content = DecodeHtml(node2->GetText());
			}// end of for loop
			error = _customerReviews->reviews.Append(review);
		}
	}// end of for loop


	return error;
}

//Get similar products information
SFCError AWSProduct::ParseSimilarProducts(SFXXMLNodePtr node)
{
	SFCError error(SFERR_NO_ERROR);

	if (node == null) return SFERR_FAILED;

	_similarProducts = new SimilarProductsRec;
	if (_similarProducts == null) return SFERR_NO_MEMORY;

	for (; node != null && error == SFERR_NO_ERROR; node = node->GetNextSibling())
	{
		if (SFXAnsiString(node->GetNodeName()) == "SimilarProduct") 
		{
			SFXXMLNodePtr node2(node->GetFirstChild());
			SimilarProductRecPtr similarProduct = new SimilarProductRec;
			if (similarProduct == null) return SFERR_NO_MEMORY;
			
			for (; node2 != null; node2 = node2->GetNextSibling()) 
			{
				if (SFXAnsiString(node2->GetNodeName()) == "ASIN")
					similarProduct->asin = DecodeHtml(node2->GetText());
				else if (SFXAnsiString(node2->GetNodeName()) == "Title")
					similarProduct->title = DecodeHtml(node2->GetText());
			}
			error = _similarProducts->similarProducts.Append(similarProduct);
		 }
	}

    return error;
}


// Not yet implimentation.
SFCError AWSProduct::ParseBrowserNodes(SFXXMLNodePtr /*node*/){ return SFERR_NO_ERROR;}
SFCError AWSProduct::ParseListmaniaLists(SFXXMLNodePtr /*node*/){ return SFERR_NO_ERROR;}

//this helper function is used by MakeReviewPane
SInt32 SearchBrTag(SFXAnsiStringConstRef string, SInt32 index = -1)
{
    SInt32 brc(string.FirstIndexOf("<BR>", index));
    SInt32 br(string.FirstIndexOf("<br>", index));
    SInt32 pc(string.FirstIndexOf("<P>", index));
    SInt32 p(string.FirstIndexOf("<p>", index));

    br = (brc < br && brc >= 0 || br < 0) ? brc : br;
    pc = (pc < p && pc >= 0 || p < 0) ? pc : p;
    return (br < pc && br >= 0 || pc < 0) ? br : pc;
}

//This pane is identical to all products
SFCError AWSProduct::MakeReviewPane(SFRTabControlPtr tab)
{
	SFCError error(SFERR_NO_ERROR);
	ScrollTabPanePtr pane;

    SInt16 i, height;

	if ((pane = ::new ScrollTabPane(tab, "Reviews")) == null) 
		return SFERR_NO_MEMORY;
   
    if ((error = pane->static_catch()) != SFERR_NO_ERROR) 
		return error;

	SFXRectangle temp(pane->GetContentWorld().Deflate(CONTROL_MARGIN, CONTROL_MARGIN));
	temp.SetHeight(SFXGraphics::GetFontHeight(AEE_FONT_NORMAL));

    if (_customerReviews == null) 
	{
		if ((::new SFRLabelControl(pane, temp, "No review"), SFRLabelControl::ALIGN_LEFT) == null) 
			return SFERR_NO_MEMORY;

		return SFERR_NO_ERROR;
	}

	if ((::new SFRLabelControl(pane, temp, SFXWideString::Format("Average Rating: %d", _customerReviews->averageRating), SFRLabelControl::ALIGN_LEFT)) == null)
		return SFERR_NO_MEMORY;

	temp.AddY(temp.GetHeight());
	
	for (i = 0; i < _customerReviews->totalReviews && i < 5; ++i) 
	{ // display up to 5 reviews
		temp.AddY(3 * CONTROL_MARGIN);
		temp.SetHeight(SFXGraphics::GetFontHeight(AEE_FONT_NORMAL));
		SFRLabelControlPtr label(::new SFRLabelControl(pane, temp, SFXWideString::Format("Reviewer%d: %d", i + 1, _customerReviews->reviews[i]->rating), SFRLabelControl::ALIGN_LEFT));
                
		if (label == null) 
			return SFERR_NO_MEMORY;
		
		label->SetColor(SFRLabelControl::COLOR_TITLE, SFXRGBColor(0xFF, 0x00, 0x00, 0x00));
		temp.AddY(temp.GetHeight() + CONTROL_MARGIN);
		height = SFXGraphics::MeasureString(AEE_FONT_NORMAL, _customerReviews->reviews[i]->summary, temp.GetWidth());
		temp.SetHeight(height);

		label = ::new SFRLabelControl(pane, temp, _customerReviews->reviews[i]->summary, SFRLabelControl::ALIGN_LEFT);
                    
		if (label == null) 
			return SFERR_NO_MEMORY;

		label->SetColor(SFRLabelControl::COLOR_TITLE, SFXRGBColor(0x00, 0x00, 0xFF, 0x00));
		temp.AddY(temp.GetHeight() + CONTROL_MARGIN);

		SFXAnsiStringConstRef string(_customerReviews->reviews[i]->content);

		SInt32 br1(SearchBrTag(string));
			
		br1 = (br1 > -1) ? br1 : SINT32_MAXIMUM;
		SInt32 br2(0);

		do {
			SFXWideString tempString(string.Substring(br2, br1));
			height = SFXGraphics::MeasureString(AEE_FONT_NORMAL, tempString, temp.GetWidth());
			temp.SetHeight(height);
				
			if ((::new SFRLabelControl(pane, temp, tempString, SFRLabelControl::ALIGN_LEFT)) == null) 
				return SFERR_NO_MEMORY;

			temp.AddY(temp.GetHeight());
			
			// br1: BR or P?
			br2 = string.FirstIndexOf('>', br1) + 1;

			br1 = SearchBrTag(string, br2);
			if (br1 < 0)	br1 = SINT32_MAXIMUM;
		} while (br2 > 0);
	}//end for
       
	pane->SetHeight(temp.GetTop());

	return error;
}

//This pane is identical to all products
SFCError AWSProduct::MakeSimilarPane(SFRTabControlPtr tab)
{
    SFCError error(SFERR_NO_ERROR);
    AWSTabPanePtr pane;
    UInt16 i;

	if (_similarProducts == null) 
		return SFERR_FAILED;

	if ((pane = ::new AWSTabPane(tab, "Related Products")) == null) return SFERR_NO_MEMORY;

    if ((error = pane->static_catch()) != SFERR_NO_ERROR) 
		return error;

	for (i = 0; i < _similarProducts->similarProducts.GetSize(); ++i) 
	{
		if ((error = pane->Append("ASIN", _similarProducts->similarProducts[i]->asin)) != SFERR_NO_ERROR)
			return error;
		
		if ((error = pane->Append("Title", _similarProducts->similarProducts[i]->title)) != SFERR_NO_ERROR)
			return error;
	}

    error = pane->MakeLabels();
    return error;
}

//This pane is identical to all products
SFCError AWSProduct::MakeImagePane(SFRTabControlPtr tab)
{
	SFCError error(SFERR_NO_ERROR);

	if (_imageUrl == null) return SFERR_FAILED;

	if ((::new AWSImageTabPane(tab, "Image", _imageUrl->mediumImageURL, _asin))==null)
        return SFERR_NO_MEMORY;

	return error;
}

// dispaly product information
SFCError AWSProduct::DisplayMe(SFXAnsiStringConstRef producttype, bool addedFavorite)
{
	AWSDisplayWindowPtr _displaywindow;
	SFRTabControlPtr _tab;
    SFXRectangle _rect;
    SFCError error(SFERR_NO_ERROR);

	//create display window
	if ((_displaywindow  = ::new AWSDisplayWindow(producttype, _asin, _title, addedFavorite)) == null)
		return SFERR_NO_MEMORY;

    _rect = _displaywindow->GetContentWorld();
    _rect.AddTop(TOP_MARGIN);

	//create tab control
    if ((_tab = ::new SFRTabControl(_displaywindow, _rect)) == null)
       return SFERR_NO_MEMORY;
	
	//create panes
	if ((error = _tab->static_catch()) != SFERR_NO_ERROR)
		return error;
            
	if ((error = MakeGeneralPane(_tab)) != SFERR_NO_ERROR)
		return error;
                
	if ((error = MakeDetailPane(_tab)) != SFERR_NO_ERROR)
		return error;
	
	if ((error = MakeReviewPane(_tab)) != SFERR_NO_ERROR)
	    return error;

    if ((error = MakeSimilarPane(_tab)) != SFERR_NO_ERROR)
		return error;
     
    if ((error = MakeImagePane(_tab)) != SFERR_NO_ERROR)
		return error;

	return error;
}
//++++++++++++++++++++++End of AWSProduct class implementation++++++++++++++++++++++++++//


//++++++++++++++++++++++++++AWSBook class implementation+++++++++++++++++++++++++++++//
AWSBook::AWSBook(Void): AWSProduct()
{
	_itemAttributes = null;
	return;
}

AWSBook::~AWSBook(Void)
{
	if (_itemAttributes != null)
	{
		delete _itemAttributes;
		_itemAttributes = null;
	}

	return;
}

// Get book itemattributes
SFCError AWSBook::ParseItemAttributes(SFXXMLNodePtr node)
{
	SFCError error(SFERR_NO_ERROR);

	if (node == null) return SFERR_FAILED;

    _itemAttributes = new BookItemAttributesRec;
		
	if (_itemAttributes == null) return SFERR_NO_MEMORY;
        
    _itemAttributes->numberOfPages = 0;
    _itemAttributes->packageDimensionsLength = 0;
    _itemAttributes->packageDimensionsWidth = 0;
            
	for (; node != null && error == SFERR_NO_ERROR; node = node->GetNextSibling()) 
	{
		if (SFXAnsiString(node->GetNodeName()) == "Author")
		{
			SFXAnsiStringPtr author = new SFXAnsiString(DecodeHtml(node->GetText()).GetCString());
			_itemAttributes->authors.Append(author);
		}
		else if (SFXAnsiString(node->GetNodeName()) == "Binding") 
			_itemAttributes->binding = DecodeHtml(node->GetText());
        
		else if (SFXAnsiString(node->GetNodeName()) == "ListPrice") 
		{
			SFXXMLNodePtr node2(node->GetFirstChild());
            for (; node2 != null; node2 = node2->GetNextSibling()) 
			{
				if (SFXAnsiString(node2->GetNodeName()) == "Amount") 
					_itemAttributes->amount = node2->GetText().AsSInt32();
                else if (SFXAnsiString(node2->GetNodeName()) == "CurrencyCode") 
                    _itemAttributes->currencyCode = DecodeHtml(node2->GetText());
                else if (SFXAnsiString(node2->GetNodeName()) == "FormattedPrice")
                    _itemAttributes->formattedPrice = DecodeHtml(node2->GetText());
            } 
		}
		else if (SFXAnsiString(node->GetNodeName()) == "NumberOfPages") 
			_itemAttributes->numberOfPages = node->GetText().AsSInt32();
        else if (SFXAnsiString(node->GetNodeName()) == "PackageDimensions") 
		{
			SFXXMLNodePtr node2(node->GetFirstChild());
            for (; node2 != null; node2 = node2->GetNextSibling()) 
			{
				if (SFXAnsiString(node2->GetNodeName()) == "Length")
					_itemAttributes->packageDimensionsLength = node2->GetText().AsSInt32();
                else if (SFXAnsiString(node2->GetNodeName()) == "Width")
                    _itemAttributes->packageDimensionsWidth = node2->GetText().AsSInt32();
            }
        } 
		else if (SFXAnsiString(node->GetNodeName()) == "PublicationDate") 
            _itemAttributes->publicationDate = StringToDate(node->GetText());
        else if (SFXAnsiString(node->GetNodeName()) == "Publisher")
            _itemAttributes->publisher = DecodeHtml(node->GetText());
        else if (SFXAnsiString(node->GetNodeName()) == "Title") 
            _title = DecodeHtml(node->GetText());
    }//end for

    return error;
}

//Create pane to display general information
SFCError AWSBook::MakeGeneralPane(SFRTabControlPtr tab)
{
    SFCError error(SFERR_NO_ERROR);
    AWSTabPanePtr pane;
    UInt16 i;
    
	if (_itemAttributes == null) return SFERR_FAILED;

	if ((pane = ::new AWSTabPane(tab, "General")) == null) return SFERR_NO_MEMORY;

	if ((error = pane->static_catch()) != SFERR_NO_ERROR)
		return error;
    
	if ((error = pane->Append("Title", _title)) != SFERR_NO_ERROR)
		return error;

	if (_itemAttributes->authors.GetSize()>0)
	{
		SFXAnsiString authors = _itemAttributes->authors[0]->TrimLeft();
		for (i = 1; i < _itemAttributes->authors.GetSize(); ++i) 
			authors = authors + ", " + _itemAttributes->authors[i]->TrimLeft();
		if ((error = pane->Append("Author(s)", authors)) != SFERR_NO_ERROR)
			return error;
	}
    
	if ((error = pane->Append("Price", _itemAttributes->formattedPrice)) != SFERR_NO_ERROR)
		return error;
	 
	error = pane->MakeLabels();
    return error;
}

// create pane for detailed information
SFCError AWSBook::MakeDetailPane(SFRTabControlPtr tab)
{
    SFCError error(SFERR_NO_ERROR);
    AWSTabPanePtr pane;

	if (_itemAttributes == null) return SFERR_FAILED;

	if ((pane = ::new AWSTabPane(tab, "Details")) == null) return SFERR_NO_MEMORY;
	
	if ((error = pane->static_catch()) != SFERR_NO_ERROR) 
		return error;
	
	if ((error = pane->Append("Publisher", _itemAttributes->publisher)) != SFERR_NO_ERROR)
		return error;
			
	if ((error = pane->Append("Pubish date", (_itemAttributes->publicationDate.AsUInt32() == 0) ? ("Unknown") : (_itemAttributes->publicationDate.Format("YYYY/MM/DD")))) != SFERR_NO_ERROR) 
		return error;
			
	if ((error = pane->Append("Type", _itemAttributes->binding)) != SFERR_NO_ERROR)
		return error;
			
	if ((error = pane->Append("ISBN", _asin)) != SFERR_NO_ERROR)
		return error;
			
	if ((error = pane->Append("Pages", _itemAttributes->numberOfPages)) != SFERR_NO_ERROR) 
		return error;
		
	if ((error = pane->Append("Length", _itemAttributes->packageDimensionsLength)) != SFERR_NO_ERROR) 
		return error;
		
	if ((error = pane->Append("Width", _itemAttributes->packageDimensionsWidth)) != SFERR_NO_ERROR) 
		return error;

	error = pane->MakeLabels();
    return error;
}

//++++++++++++++++++++++End of AWSBook class implementation++++++++++++++++++++++++++//

//++++++++++++++++++++++++++AWSDvd class implementation+++++++++++++++++++++++++++++//
AWSDvd::AWSDvd(Void): AWSProduct()
{
	_itemAttributes = null;
	return;
}

AWSDvd::~AWSDvd(Void)
{
	if (_itemAttributes != null)
	{
		delete _itemAttributes;
		_itemAttributes = null;
	}

	return;
}

// Get DVD itemattributes
SFCError AWSDvd::ParseItemAttributes(SFXXMLNodePtr node)
{
    SFCError error(SFERR_NO_ERROR);

	if (node == null)
		return SFERR_FAILED;

    _itemAttributes = new DvdItemAttributesRec;
	if (_itemAttributes == null) return SFERR_NO_MEMORY;
        
	for (; node != null && error == SFERR_NO_ERROR; node = node->GetNextSibling()) 
	{
		if (SFXAnsiString(node->GetNodeName()) == "Actor")
		{
			SFXAnsiStringPtr actor = new SFXAnsiString(DecodeHtml(node->GetText()).GetCString());
			_itemAttributes->actors.Append(actor);
		}
		if (SFXAnsiString(node->GetNodeName()) == "Director")
		{
			SFXAnsiStringPtr director = new SFXAnsiString(DecodeHtml(node->GetText()).GetCString());
			_itemAttributes->directors.Append(director);
		}
		if (SFXAnsiString(node->GetNodeName()) == "Format")
		{
			SFXAnsiStringPtr format = new SFXAnsiString(DecodeHtml(node->GetText()).GetCString());
			_itemAttributes->formats.Append(format);
		}
		else if (SFXAnsiString(node->GetNodeName()) == "ListPrice") 
		{
			SFXXMLNodePtr node2(node->GetFirstChild());
            for (; node2 != null; node2 = node2->GetNextSibling()) 
			{
				if (SFXAnsiString(node2->GetNodeName()) == "Amount") 
					_itemAttributes->amount = node2->GetText().AsSInt32();
                else if (SFXAnsiString(node2->GetNodeName()) == "CurrencyCode") 
                    _itemAttributes->currencyCode = DecodeHtml(node2->GetText());
                else if (SFXAnsiString(node2->GetNodeName()) == "FormattedPrice")
                    _itemAttributes->formattedPrice = DecodeHtml(node2->GetText());
            } //end for
		}
		
		else if (SFXAnsiString(node->GetNodeName()) == "Publisher")
            _itemAttributes->publisher = DecodeHtml(node->GetText());
		else if (SFXAnsiString(node->GetNodeName()) == "ReleaseDate") 
            _itemAttributes->releaseDate = StringToDate(node->GetText());
		else if (SFXAnsiString(node->GetNodeName()) == "RunningTime") 
			_itemAttributes->runningTime = node->GetText().AsSInt32();
        else if (SFXAnsiString(node->GetNodeName()) == "Title") 
            _title = DecodeHtml(node->GetText());
    }//end for

    return error;
}

//Create pane to display general information
SFCError AWSDvd::MakeGeneralPane(SFRTabControlPtr tab)
{
    SFCError error(SFERR_NO_ERROR);
    AWSTabPanePtr pane;
    UInt16 i;
    
	if (_itemAttributes == null) return SFERR_FAILED;
	
	if ((pane = ::new AWSTabPane(tab, "General")) == null) return SFERR_NO_MEMORY;

	if ((error = pane->static_catch()) != SFERR_NO_ERROR)
		return error;
    
	if ((error = pane->Append("Title", _title)) != SFERR_NO_ERROR)
		return error;

	if (_itemAttributes->directors.GetSize()>0)
	{
		SFXAnsiString directors = _itemAttributes->directors[0]->TrimLeft();
		for (i = 1; i < _itemAttributes->directors.GetSize(); ++i) 
			directors = directors + ", " + _itemAttributes->directors[i]->TrimLeft();
		if ((error = pane->Append("Director(s)", directors)) != SFERR_NO_ERROR)
			return error;
    }
	if ((error = pane->Append("Price", _itemAttributes->formattedPrice)) != SFERR_NO_ERROR)
		return error;
	 
	error = pane->MakeLabels();
    return error;
}

// create pane for detailed information
SFCError AWSDvd::MakeDetailPane(SFRTabControlPtr tab)
{
    SFCError error(SFERR_NO_ERROR);
    AWSTabPanePtr pane;
	UInt16 i;

	if (_itemAttributes == null) return SFERR_FAILED;
    
	if ((pane = ::new AWSTabPane(tab, "Details")) == null) return SFERR_NO_MEMORY;

	if ((error = pane->static_catch()) != SFERR_NO_ERROR) 
		return error;

	if (_itemAttributes->actors.GetSize()>0)
	{
		SFXAnsiString actors = _itemAttributes->actors[0]->TrimLeft();
	    for (i = 1; i < _itemAttributes->actors.GetSize(); ++i) 
			actors = actors + ", " + _itemAttributes->actors[i]->TrimLeft();
		if ((error = pane->Append("Actor(s)", actors)) != SFERR_NO_ERROR)
			return error;
	}

	if (_itemAttributes->formats.GetSize()>0)
	{
		SFXAnsiString formats = _itemAttributes->formats[0]->TrimLeft();
		for (i = 1; i < _itemAttributes->formats.GetSize(); ++i) 
			formats = formats + ", " + _itemAttributes->formats[i]->TrimLeft();
		if ((error = pane->Append("Format", formats)) != SFERR_NO_ERROR)
			return error;
	}
	
	if ((error = pane->Append("ASIN", _asin)) != SFERR_NO_ERROR)
		return error;

	if ((error = pane->Append("Publisher", _itemAttributes->publisher)) != SFERR_NO_ERROR)
		return error;
			
	if ((error = pane->Append("Release date", (_itemAttributes->releaseDate.AsUInt32() == 0) ? ("Unknown") : (_itemAttributes->releaseDate.Format("YYYY/MM/DD")))) != SFERR_NO_ERROR) 
		return error;
		
	if ((error = pane->Append("Time (min)", _itemAttributes->runningTime)) != SFERR_NO_ERROR) 
		return error;

	error = pane->MakeLabels();
    return error;
}
