//
//      AWSTabControl.hpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.1.1
//

/**
***	Project         : Amazon Products Viewing
***	File			: AWSTabControl.hpp	
***	Description		: Displaying product information
**/

#ifndef __AWSTABCONTROL_HPP
#define __AWSTABCONTROL_HPP

#include <SophiaFramework.hpp>

//LinkLabel class
SFMRESPONDERBEHAVIOR(LINKLABEL, BEHAVIOR_SFRCONTROL, PROPERTY_DIRECT,  APPEARANCE_TRANSPARENT)
SFMTYPEDEFCLASS(LinkLabel)
class LinkLabel : public SFRButtonBase {
private:
    SFXWideString _title;
public:
    LinkLabel(SFRResponderPtr, SFXRectangleConstRef, SFXWideStringConstRef, BehaviorType = BEHAVIOR_LINKLABEL);
    ~LinkLabel(Void);
    Void SetTitle(SFXWideStringConstRef);
    SFXWideStringConstRef GetTitle(Void) const;
private:
    virtual Void HandleRelease(Void);
    virtual Void HandleContent(SFXGraphicsPtr);	

};

//ScrollTabPane class to display long information
SFMTYPEDEFCLASS(ScrollTabPane)
class ScrollTabPane : public SFRTabPane {
    SFMSEALCOPY(ScrollTabPane)
public:
    ScrollTabPane(SFRTabControlPtr tab, SFXWideStringConstRef title);
    Void SetHeight(SInt16 height);
private:
    HANDLER_DECLARE_BOOLEVENT(OnKey)
    HANDLER_DECLARE_VOIDRENDER(OnRender)
};

//AWSImageTabPane to display product information, inherits from ScrollTabPane
SFMTYPEDEFCLASS(AWSTabPane)
class AWSTabPane : public ScrollTabPane {
    SFMSEALCOPY(AWSTabPane)
private:
    SFXAnsiString	_string;
    SFXProperty		_value;
    UInt16			_maxWidth;
public:
    AWSTabPane(SFRTabControlPtr tab, SFXWideStringConstRef title);
    virtual ~AWSTabPane(Void);
    SFCError MakeLabels(Void);
	SFCError MakeLabelsLineFeed(Void);
    SFCError Append(SFXAnsiStringConstRef name, SFXAnsiStringConstRef value);
    SFCError Append(SFXAnsiStringConstRef name, SInt32 value);
    Void Clear(Void);
private:
    HANDLER_DECLARE_VOIDCONTROL(OnLink)
};

// AWSImageTabPane class to display product image, inherits from ScrollTabPane
SFMTYPEDEFCLASS(AWSImageTabPane)
class AWSImageTabPane : public ScrollTabPane {
    SFMSEALCOPY(AWSImageTabPane)
private:
    SFXHTTPConnection		_http;
    SFXBinaryStreamReader	_reader;
    SFXAnsiString			_url;
    SFXAnsiString			_asin;
    SFXBuffer				_imageBuffer;
    SFBImageSmp				_image;
public:
    AWSImageTabPane(SFRTabControlPtr tab, SFXWideStringConstRef title, SFXAnsiStringConstRef url, SFXAnsiStringConstRef asin);
    virtual ~AWSImageTabPane(Void);
private:
    Void ProceedNetworkError(Void);
    HANDLER_DECLARE_VOIDRENDER(OnRenderContent)
    HANDLER_DECLARE_VOIDCONTROL(OnButtonControl)

    // Callback function: begin HTTP connection
    CALLBACK_DECLARE_SFXHTTPCONNECTION(ConnectCallback)
    // Callback function: HTTP information receiving
    CALLBACK_DECLARE_SFXBINARYSTREAMREADER(FetchCallback)
};

//AWSDisplayWindow includes tabs to display product information
SFMRESPONDERATTRIBUTE(AWSDISPLAYWINDOW, four_char_code('D', 'i', 's', 'p'))

SFMTYPEDEFCLASS(AWSDisplayWindow)
class AWSDisplayWindow : public SFRPlainWindow {
    SFMSEALCOPY(AWSDisplayWindow)
private:
    enum {
        OPERATION_ADD,
        OPERATION_BACK,
        OPERATION_LIMIT
    };
	
	SFXAnsiString	_searchindex;		// product type of dislayed product
	SFXAnsiString	_asin;				// asin of dislayed product
	SFXAnsiString	_title;				// title of dislayed product
	Bool			_addedToFavorites;	// does this product exist in favorite list?
	SFXAnsiString	_favoriteFileName;	// favorite file name

public:
    explicit AWSDisplayWindow(SFXAnsiStringConstRef searchindex, SFXAnsiStringConstRef asin, SFXAnsiStringConstRef	title, Bool addedToFavorites) static_throws;
    virtual ~AWSDisplayWindow(Void);

private:
    HANDLER_DECLARE_BOOLEVENT(OnKey)
    HANDLER_DECLARE_VOIDEVENT(OnSoftkey)
    HANDLER_DECLARE_VOIDMENU(FromSoftkey)

	SFCError AddToFavorites(Void);
};

#endif // __AWSTABCONTROL_HPP //
