//
//      ListProductsWindow.cpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.1.1
//

#include "pself3.hpp"
#include "pself3_res.h"
#include "ListProductsWindow.hpp"
#include "SGRSoftkeyWindow.hpp"
#include "SGRSoftkeyToolbox.hpp"

enum {
    OPERATION_REMOVE,
    OPERATION_REMOVEALL,
    OPERATION_RETURN,
    OPERATION_LIMIT
};

ListProductsWindow::ListProductsWindow(AWSListProductsPtr products, SFXAnsiStringConstRef searchindex, SInt16 windowtype) static_throws : 
	SFRPlainWindow(SFRApplication::GetInstance(), SGRSoftkeyToolbox::GetWindowPosition(), BEHAVIOR_SFRPLAINWINDOW, ATTRIBUTE_LISTPRODUCTSWINDOW),_products(products),_searchindex(searchindex), _windowtype(windowtype)
{
    SGRSoftkeyWindowPtr softkey;
    SFXRectangle rect;
    UInt16 i;

    SGRSoftkeyWindow::Initialize(this);

    if (!static_try()) return; 
	
    // drawing handler registering
    static_throw(RegisterHandler(SREVT_RESPONDER_RENDER, SRP16_RENDER_CONTENT, HANDLER_BEFORE, HANDLER_FUNCTION(OnRender)));
    if (!static_try()) return; 
		
    // softkey handler register
    static_throw(RegisterHandler(static_cast<SFCEventEnum>(SGRSoftkeyWindow::USEREVT_SOFTKEY), HANDLER_AFTER, HANDLER_FUNCTION(OnSoftkey)));
    if (!static_try()) return;

	// calculate the drawing area for the list
	rect = GetContentWorld();
	rect.AddTop(SFXGraphics::GetFontHeight(AEE_FONT_NORMAL) + FONT_MARGIN);
	rect.Deflate(LISTBOX_MARGIN, LISTBOX_MARGIN);

	// Create list box control

    if ((_list = ::new SGRListboxControl(this, rect)) == null) return;

    static_throw(*_list);
    if (!static_try())
	{
		static_throw(SFERR_NO_MEMORY);
		return;
	}

    // list box handler registering

    static_throw(_list->RegisterHandler(SREVT_CONTROL, HANDLER_AFTER, HANDLER_FUNCTION(OnControl)));
    if (!static_try()) return;

    // softkey registering
	if ((softkey = SGRSoftkeyWindow::GetInstance()) == null) return;
	
    static_throw(softkey->Register(this, SGRSoftkeyWindow::SOFTKEY_1, "End"));
    if (!static_try()) return;

    static_throw(softkey->Register(this, SGRSoftkeyWindow::SOFTKEY_2, (_windowtype == 0)? "Back" : "Menu"));
    if (!static_try()) return;
                                        
	static_throw(softkey->Register(this, SGRSoftkeyWindow::SOFTKEY_3, "Detail"));
    if (!static_try()) return;
    
	SetReference(softkey->Bind(this));
    if (!static_try()) return;
	
	//Populate the list
	UInt16 size = _products->GetSize(); 
    for (i = 0;  i < size ; i++) 
	{
		SFXAnsiString title_utf8, title_jis;
		title_utf8= _products->GetProduct(i)->GetTitle(); // this is utf8
		SFXTextEncoding::UTF8ToShiftJIS(title_utf8, &title_jis); // convert to ShiftJIS
        _list->Append(title_jis);
    }

    return;
}

ListProductsWindow::~ListProductsWindow(Void)
{
    SGRSoftkeyWindow::Terminate(this);

	_searchindex.Clear();
	
	if (_products != null)
	{
		delete _products;
		_products = null;
	}

	if (_list != null)
	{
		delete _list;
		_list = null;
	}

    return;
}

// Drawing handler
HANDLER_IMPLEMENT_VOIDRENDER(ListProductsWindow, OnRender, graphics)
{
    static SFXBevelColor::AtomRecConst theme[] = {
        {
            {0x00, 0xFF, 0xFF, 0xFF},
            {0x00, 0xCC, 0xCC, 0xCC},
            {0x00, 0x88, 0x88, 0x88}
        },
        {
            {0x00, 0xFF, 0xFF, 0xFF},
            {0x00, 0xEE, 0xEE, 0xEE},
            {0x00, 0x88, 0x88, 0x88}
        }
    };
    static SFXRGBColor::AtomRecConst black = {
        0x00, 0x00, 0x00, 0x00
    };
    SFXRectangle top;
    SFXRectangle bottom(GetContentWorld());

    top = bottom;
    top.SetHeight(graphics->GetFontHeight() + FONT_MARGIN);
    graphics->FillBevelHorizontal(top, theme[0]);

	 // display title
	if (_windowtype == SEARCHWINDOW)
		graphics->DrawText("Search Result", top, black);
    else if (_windowtype == FAVORITEWINDOW)
		graphics->DrawText("Favorites", top, black);

	bottom.SetTop(top.GetBottom());
    graphics->FillBevelHorizontal(bottom, theme[1]);
    return;
}

// list selected item handler
HANDLER_IMPLEMENT_VOIDCONTROL(ListProductsWindow, OnControl, result, control)
{
    unused(control);

    SFCError error(SFERR_NO_ERROR);

	SFXHelper::dbgprintf("--------------------XML");


    switch (result) {
		case SRP16_ESCAPE:
            // destroy this window
            Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE, SRP16_TERMINATE_INVOKE, true));
            break;
        default:
            // display product information
			SFXWideString string;
			SFRMultiDialog::ParamRec param;
			Bool b;

			string = _products->GetProduct(_list->GetSelect())->GetAsin();

			SFXPathConst filename(DIR_NAME + string + ".xml");

			SFXFile::Exists(filename, &b);
			if (!b) //if this product not exists then connect to AWS to get information
			{				
				SOAP_ParamsPtr	_params = new SOAP_Params;
				_params->operation		= "ItemLookup";
				_params->response_group = "Large";
				
				_params->asin			=	string;	
					
				_params->_set_search_index	= false;
				_params->_set_browse_node	= false;
				_params->_set_keyword		= false;
				_params->_set_asin			= true;

				_soapDialog.Open(_params, true, OnNetworkEntry, this, "Confirm", "Connect to internet?", "Yes", "No" );
			}
			else //load product information from XML file
			{				
				AWSListProductsPtr	_listoneproduct;

				_listoneproduct = ::new AWSListProducts();
				if(_listoneproduct == null) return;

				error = _listoneproduct->GetXMLProducts(filename,_searchindex);
				if (error != SFERR_NO_ERROR) return;

				error= _listoneproduct->GetProduct(0)->DisplayMe(_searchindex, EXIST_FAVORITE);
			}
	        break;
    }
    return;
}

// softkey handler
HANDLER_IMPLEMENT_VOIDEVENT(ListProductsWindow, OnSoftkey, event)
{
    SFCError error(SFERR_NO_ERROR);

    switch (event.GetP16()) 
	{
        case SGRSoftkeyWindow::SOFTKEY_1:
			// terminate application
			SFRApplication::Terminate();
            break;
        case SGRSoftkeyWindow::SOFTKEY_2:
			// if this is search result window then close it	
			if (_windowtype == SEARCHWINDOW)
				Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE, SRP16_TERMINATE_INVOKE, true));
			else if (_windowtype == FAVORITEWINDOW)
			{// create a menu for favorite window
				SFRTextMenuPtr menu;
				
				if ((menu = ::new SFRTextMenu(SGRSoftkeyToolbox::GetMenuPosition(OPERATION_LIMIT), "Menu", null, 0)) == null)
				return;

                if ((error = menu->static_catch()) != SFERR_NO_ERROR)
				{
					delete menu;
					return;
				}
                
				if ((error = menu->AppendItem("Delete", AVK_1, 0xFBF6)) == SFERR_NO_ERROR)
					if ((error = menu->AppendItem("Delete All", AVK_2, 0xFCF6)) == SFERR_NO_ERROR)
						if ((error = menu->AppendItem("Back", AVK_3, 0x40F7)) == SFERR_NO_ERROR)
							error = SGRSoftkeyToolbox::OpenStandardMenu(menu, HANDLER_FUNCTION(FromSoftkey));
                                        
                if (error != SFERR_NO_ERROR) ::delete menu;
                
			}
            break;
    }
    return;
}
// menu items handler
HANDLER_IMPLEMENT_VOIDMENU(ListProductsWindow, FromSoftkey, result, menu)
{
    SFRMultiDialogPtr dialog;
    SFRMultiDialog::ParamRec param;
    SFXWideString title;
	SInt32 titlelength; 

    switch (result) {
        case OPERATION_REMOVE: // delete selected item

			// close menu
			SGRSoftkeyToolbox::CloseStandardMenu(menu);
			
			if(_list->GetItemCount()<=0) return;

			title = _products->GetProduct(_list->GetSelect())->GetTitle();

			titlelength = title.GetLength();

			if( titlelength != 0)
			{
				// parameters for dialog
				param.text = "Delete \"" + title + "\"H";
				param.ok = "Yes";
				param.cancel = "Cancel";
				param.focus = SFRMultiDialog::FOCUS_CANCEL;
				param.image = SFBShell::GetInstance()->LoadResImage(PSELF3_RES_FILE, ACCEPT);
					
				// create dialog

				if ((dialog = ::new SFRMultiDialog(SGRSoftkeyToolbox::GetDialogPosition(SFRMultiDialog::GetMargin(), MULTIDIALOG_REMOVE_HEIGHT), "Confirm", param)) != null)
					SGRSoftkeyToolbox::OpenStandardDialog(dialog, HANDLER_FUNCTION(FromRemove));
			}
			break;
        case OPERATION_REMOVEALL: // delete all items
			
			// close menu
			SGRSoftkeyToolbox::CloseStandardMenu(menu);

			if(_list->GetItemCount()>0){

				// parameters for dialog
				param.text = "Are you sure you want to delete all?";
				param.ok = "Yes";
				param.cancel = "Cancel";
				param.focus = SFRMultiDialog::FOCUS_CANCEL;
				param.image = SFBShell::GetInstance()->LoadResImage(PSELF3_RES_FILE, ACCEPT);

				// create dialog
				if ((dialog = ::new SFRMultiDialog(SGRSoftkeyToolbox::GetDialogPosition(SFRMultiDialog::GetMargin(), MULTIDIALOG_REMOVEALL_HEIGHT), "mF", param)) != null) 
					SGRSoftkeyToolbox::OpenStandardDialog(dialog, HANDLER_FUNCTION(FromRemoveAll));
				
			}
            break;

        case OPERATION_RETURN:
            // close menu
            SGRSoftkeyToolbox::CloseStandardMenu(menu);
            // destroy this window
            Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE, SRP16_TERMINATE_INVOKE, true));
            break;

        case SRP16_ESCAPE:
        case SRP16_CANCEL:
            // close menu
            SGRSoftkeyToolbox::CloseStandardMenu(menu);
            break;
    }
    return;
}

// "Delete" is selected and button is pressed handler 
HANDLER_IMPLEMENT_VOIDDIALOG(ListProductsWindow, FromRemove, result, dialog)
{
    SFRMultiDialogPtr dialog2;
    SFRMultiDialog::ParamRec param;

    switch (result) {
        case SRP16_OK: // if Yes
            // Close dialog
            SGRSoftkeyToolbox::CloseStandardDialog(dialog);

            // delete a product from list of products and delete related files
			_products->RemoveProduct(_products->GetProduct(_list->GetSelect())->GetAsin());

			// update favorite file
			_products->UpdateFavoriteFile(SFXPath(DIR_NAME + _searchindex + ".dat"));

            // delete from list
			_list->Remove(_list->GetSelect());

			// dialog parameters
			param.text = "Deleted";
			param.ok = "OK";
			param.cancel = "";
			param.focus = SFRMultiDialog::FOCUS_OK;
			param.image = SFBImageSmp(null);         // icon image

			// create dialog
			dialog2 = ::new SFRMultiDialog(	SGRSoftkeyToolbox::GetWindowPosition().Deflate(20, 0)
							.SetHeight(100).AddY(80),"Delete Message", param);

			if (dialog2 != null) 
				dialog2->RegisterHandler(SREVT_DIALOG, HANDLER_BEFORE, HANDLER_FUNCTION(OnDialog));
                
            break;
        case SRP16_ESCAPE: 
        case SRP16_CANCEL: 
            // close dialog
            SGRSoftkeyToolbox::CloseStandardDialog(dialog);
            break;
    }
    return;
}

// "Delete All" is selected and button is pressed handler 
HANDLER_IMPLEMENT_VOIDDIALOG(ListProductsWindow, FromRemoveAll, result, dialog)
{
    SFRMultiDialogPtr dialog2;
    SFRMultiDialog::ParamRec param;

    switch (result) {
        case SRP16_OK: // If Yes
            SGRSoftkeyToolbox::CloseStandardDialog(dialog);

            // delete all products from product list and related files
			_products->RemoveAllProducts();

			// delete favorite
			SFXFile::Remove(SFXPath(DIR_NAME + _searchindex + ".dat"));
			
			// clear the list
			_list->Clear();

			// dialog parameters
			param.text = "All deleted";
			param.ok = "OK";
			param.cancel = "";
			param.focus = SFRMultiDialog::FOCUS_OK;
			param.image = SFBImageSmp(null);         // icon image

			// create dialog
			dialog2 = ::new SFRMultiDialog(SGRSoftkeyToolbox::GetWindowPosition().Deflate(20, 0)
							.SetHeight(100).AddY(80),"Delete Message", param);

            if (dialog2 != null) 
                    dialog2->RegisterHandler(SREVT_DIALOG, HANDLER_BEFORE, HANDLER_FUNCTION(OnDialog));

            break;

        case SRP16_ESCAPE:
        case SRP16_CANCEL: 
            // close dialog
            SGRSoftkeyToolbox::CloseStandardDialog(dialog);
            break;
    }
    return;
}


// button on "Deleted" dialog is pressed handler
HANDLER_IMPLEMENT_VOIDDIALOG(ListProductsWindow, OnDialog, result, dialog)
{
    unused(result);

    // destroy itself
     dialog->Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE, SRP16_TERMINATE_INVOKE, true));

}

Void ListProductsWindow::OnNetworkEntry(SGRSOAPDialogSet::NotifyEnum notify, SFCError error, VoidPtr reference)
{
    ListProductsWindowPtr(reference)->OnNetwork(notify, error);
}

Void ListProductsWindow::OnNetwork(SGRSOAPDialogSet::NotifyEnum notify, SFCError error)
{
    unused(error);

    switch(notify) {
        case SGRSOAPDialogSet::NOTIFY_CONNECT_START:
            break;
        case SGRSOAPDialogSet::NOTIFY_CONNECT_END:
            error = ParseXML();
			if(error != SFERR_NO_ERROR){
				_errorDialog.Open(XML_ERROR_TITLE, XML_ERROR_CODE1, DIALOG_OK, this);
			}
            break;
    }	
}

SFCError ListProductsWindow::ParseXML(Void)
{
    SFCError error = SFERR_NO_ERROR;

	// get product information
	// the list contains only 1 product

	AWSListProductsPtr	_listoneproduct;

	_listoneproduct = ::new AWSListProducts();
	if (_listoneproduct == null) return SFERR_NO_MEMORY;

	error = _listoneproduct->GetXMLProducts(_soapDialog.GetBody(), _searchindex);
	if (error != SFERR_NO_ERROR) return error;

	error= _listoneproduct->GetProduct(0)->DisplayMe(_searchindex, NOT_EXIST_FAVORITE);
	
    return error;
}

