//
//      ListProductsWindow.hpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.1.1
//

/**
***	Project         : Amazon Products Viewing
***	File			: ListProductsWindow.hpp	
***	Description		: Display search results or product favorite list
**/

#ifndef __LISTPRODUCTSWINDOW_HPP
#define __LISTPRODUCTSWINDOW_HPP

#include <SophiaFramework.hpp>
#include "SGRListboxControl.hpp"
#include "AWSListProducts.hpp"
#include "SGRSOAPDialogSet.hpp"
#include "SGRErrorDialogSet.hpp"

SFMRESPONDERATTRIBUTE(LISTPRODUCTSWINDOW, four_char_code('P', 'r', 'o', 'd'))

SFMTYPEDEFCLASS(ListProductsWindow)
class ListProductsWindow : public SFRPlainWindow {
    SFMSEALCOPY(ListProductsWindow)
private:
	SInt16					_windowtype;  // 0: search result, 1: favorite list
	SFXAnsiString			_searchindex; // product type such as Books or DVD
    AWSListProductsPtr		_products;	  // List of products	
    SGRListboxControlPtr	_list;		  // List control to display products

	SGRSOAPDialogSet		_soapDialog;
	SGRErrorDialogSet		_errorDialog;

public:
    explicit ListProductsWindow(AWSListProductsPtr products, SFXAnsiStringConstRef searchindex, SInt16 windowtype) static_throws;
    virtual ~ListProductsWindow(Void);

	static Void OnNetworkEntry(SGRSOAPDialogSet::NotifyEnum notify, SFCError error, VoidPtr reference);
    Void OnNetwork(SGRSOAPDialogSet::NotifyEnum notify, SFCError error);
	SFCError ParseXML(Void);
private:
    HANDLER_DECLARE_VOIDRENDER(OnRender)
    HANDLER_DECLARE_VOIDCONTROL(OnControl)
    HANDLER_DECLARE_VOIDEVENT(OnSoftkey)
	HANDLER_DECLARE_VOIDMENU(FromSoftkey)
	HANDLER_DECLARE_VOIDDIALOG(FromRemove)
	HANDLER_DECLARE_VOIDDIALOG(FromRemoveAll)
	HANDLER_DECLARE_VOIDDIALOG(OnDialog)

};

#endif // __LISTPRODUCTSWINDOW_HPP //
