//
//      SearchWindow.cpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.1.1
//

#include "pself3.hpp"
#include "SGRSOAPDialogSet.hpp"

#define DIALOG_OK			"OK"
#define SOAP_ERROR_TITLE	"SOAP Error"
#define SOAP_ERROR_CODE		"SOAP request failed"


// constructor
SGRSOAPDialogSet::SGRSOAPDialogSet(Void) : _dialog(null), _body(null)
{
    return;
}

//destructor
SGRSOAPDialogSet::~SGRSOAPDialogSet(Void)
{
    return;
}

// open connection confirm dialog
SFCError SGRSOAPDialogSet::Open(SOAP_ParamsPtr params, Bool isConfirm, SOAPDialogSetSPP procedure, VoidPtr data, SFXAnsiStringConstRef title, SFXAnsiStringConstRef text, SFXAnsiStringConstRef ok, SFXAnsiStringConstRef cancel)
{
    SFCError error(SFERR_NO_ERROR);

	SFXSize devsize;
	devsize = SFXGraphics::GetDeviceSize();

	SInt16Const top		= devsize.GetHeight() / 4;
	SInt16Const left	= devsize.GetWidth() / 8;
	SInt16Const width	= devsize.GetWidth() - left * 2;
	SInt16Const height	= devsize.GetHeight() - top * 2;

	_params		= params;
    _spp		= procedure;
    _reference	= data;
	_title		= title;
	_text		= text;
	_ok			= ok;
	_cancel		= cancel;

    if (isConfirm) { // open connection confirmation dialog
        SFRMultiDialog::ParamRec param;
        param.text		= _text;
        param.ok		= _ok;
        param.cancel	= _cancel;
        param.another	= "";							// set to "" for not displaying
        param.focus		= SFRMultiDialog::FOCUS_OK,		// focus on OK button
        param.image		= SFBImageSmp(null);			// no image icon
       
		if ((_dialog = ::new SFRMultiDialog( SFXRectangle(left, top ,width, height), _title, param)) == null) 
	    return SFERR_NO_MEMORY;
			
		if ((error = SGRSoftkeyToolbox::OpenStandardDialog(_dialog, HANDLER_FUNCTION(OnDialog))) == SFERR_NO_ERROR) 
			// forced redrawing
			SFRApplication::GetInstance()->Invoke(SFXEvent(SREVT_RESPONDER_RENDER, SRP16_RENDER_INVOKE, false));

        
    } 
	else{
		error = SOAPConnect(); // SOAP connection
		
		if (error != SFERR_NO_ERROR) 
			{
				_spp(NOTIFY_CONNECT_START, error, _reference);
				SGRSoftkeyToolbox::CloseStandardDialog(_dialog);
				_errorDialog.Open(SOAP_ERROR_TITLE, SOAP_ERROR_CODE, DIALOG_OK, this);
			}
    }
    return error;
}


// implement dialog handler for connection confirm dialog
HANDLER_IMPLEMENT_VOIDDIALOG(SGRSOAPDialogSet, OnDialog, result, dialog)
{
    unused(dialog);
	
	SFCError error;
	SFXRectangle rectangle;
	SFRMultiDialog::ParamRec param;

    switch (result) {
        case SRP16_OK:         // OK button is pressed
            SGRSoftkeyToolbox::CloseStandardDialog(dialog);
            rectangle.Set(SFXGraphics::GetDeviceRectangle());
            rectangle.Deflate(10, 100);

			param.text		= "Connecting...";
			param.ok		= "";
			param.cancel	= "";						 // set to "" for not displaying	
			param.another	= "";						 // set to "" for not displaying
			param.focus		= SFRMultiDialog::FOCUS_OK,  // focus on OK button
			param.image		= SFBImageSmp(null);         // no image icon
					
			if((_dialog = ::new SFRMultiDialog(rectangle, "Connect", param)) != null)
				// open the standard dialog
				SGRSoftkeyToolbox::OpenStandardDialog(_dialog, HANDLER_NULL);
			
			error = SOAPConnect();
			
			// if error occured
			if (error != SFERR_NO_ERROR) 
			{
				_spp(NOTIFY_CONNECT_START, error, _reference);
				SGRSoftkeyToolbox::CloseStandardDialog(_dialog);
				_errorDialog.Open(SOAP_ERROR_TITLE, SOAP_ERROR_CODE, DIALOG_OK, this);
			}

            break;

        case SRP16_CANCEL:     // CANCEL button is pressed
            _spp(NOTIFY_CONNECT_CANCEL, SFERR_NO_ERROR, _reference);
            SGRSoftkeyToolbox::CloseStandardDialog(dialog);
            break;
    }
}

// SOAP Connection processing
SFCError SGRSOAPDialogSet::SOAPConnect(Void)
{
    SFCError error (SFERR_NO_ERROR);
	
	_rpc.SetMethodName(_params->operation);
    
	// set target object URI
    _rpc.SetTargetObjectURI(TARGET_URI);

    // set AWSAccessKeyId
	error = _rpc.AddParameter("AWSAccessKeyId", SFXBuffer(SFXAnsiString(AMAZON_ID)));
	if (error != SFERR_NO_ERROR) return error;

	//
	// set parameters
	//

	// set request parameter
    error = _rpc.AddParameter("Request", SFXBuffer::EmptyInstance(), SFXSOAPRPC::PARAMETER::UNKNOWN);
	if (error != SFERR_NO_ERROR) return error;

	// set SearchIndex parameter
	if (_params->_set_search_index)
	{
		error = _rpc.AddParameter("SearchIndex", SFXBuffer(_params->search_index));
		if (error != SFERR_NO_ERROR) return error;
	}
	
	// set BrowseNode parameter
	if (_params->_set_browse_node)
	{
		error = _rpc.AddParameter("BrowseNode", SFXBuffer(_params->browse_node));
		if (error != SFERR_NO_ERROR) return error;
	}

	// set ResponseGroup parameter
    error = _rpc.AddParameter("ResponseGroup", SFXBuffer(_params->response_group));
	if (error != SFERR_NO_ERROR) return error;

	// set Keywords parameter
	if(_params->_set_keyword){	
		error = _rpc.AddParameter("Keywords", SFXBuffer(_params->keyword));
		if (error != SFERR_NO_ERROR) return error;
	}
	
	// set ItemId parameter
	if(_params->_set_asin)
	{
		error = _rpc.AddParameter("ItemId", SFXBuffer( _params->asin));
		if (error != SFERR_NO_ERROR) return error;
	}
	// make a remote procedure call and get the body elemnet by SOAP_Notify function 
	error = _rpc.Invoke(END_POINT_URL, SOAP_ACTION_URI, SOAP_Notify, this);
	return error;
}

Void SGRSOAPDialogSet::SOAP_Notify(SFCError error, const SFXSOAPRPC::Params& result, const SFXSOAPRPC::FAULT& fault, SFXSOAPParserConstRef soap, VoidPtr reference)
{
	DBGPRINTF("SOAP_Notify...");
	static_cast<SGRSOAPDialogSetPtr>(reference)->On_SOAP_Notify(error, result, fault, soap);
	DBGPRINTF("SOAP_Notify end");
}

Void SGRSOAPDialogSet::On_SOAP_Notify(SFCError error, const SFXSOAPRPC::Params& result, const SFXSOAPRPC::FAULT& fault, SFXSOAPParserConstRef soap )
{
	DBGPRINTF("On_SOAP_Notify...");
	// if error occured
	if (error != SFERR_NO_ERROR) 
	{
		_spp(NOTIFY_CONNECT_START, error, _reference);
		SGRSoftkeyToolbox::CloseStandardDialog(_dialog);
		_errorDialog.Open(SOAP_ERROR_TITLE, SOAP_ERROR_CODE, DIALOG_OK, this);
    }
	else// if success
	{
		_body = soap.GetBody();

		SGRSoftkeyToolbox::CloseStandardDialog(_dialog);	// close dialog
		SFRApplication::GetInstance()->Invoke( SFXEvent(SREVT_RESPONDER_RENDER, SRP16_RENDER_INVOKE, false)); // redrawing
		_spp(NOTIFY_CONNECT_END, error, _reference);
	}
	DBGPRINTF("On_SOAP_Notify end");
	return;
}
