//
//      SearchWindow.hpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.1.1
//

/**
***	Project         : Amazon Products Viewing
***	File			: SearchWindow.hpp	
***	Description		: Search window which includes panes for specific product search
**/

#ifndef __SEARCHWINDOW_HPP
#define __SEARCHWINDOW_HPP

#include <SophiaFramework.hpp>
#include "SGRSOAPDialogSet.hpp"
#include "AWSListProducts.hpp"
#include "SGRErrorDialogSet.hpp"


// Search Pane for a specific product search

SFMRESPONDERATTRIBUTE(SEARCHPANE, four_char_code('S', 'e', 'a', 'r'))

SFMTYPEDEFCLASS(SearchPane)
class SearchPane : public SFRTabPane {
    SFMSEALCOPY(SearchPane)
private:
	//SFXAnsiString _locale;				// Url address
	SFXAnsiString _searchindex;			// product type such as Books or DVD

	SFXWideString	*BrowseNodesTitle;	// product sub-categories labels used by combobox
	SFXAnsiString	*BrowseNodesValue;	// product sub-categories values
	SInt32			_size;				// number of sub-categories

	SFRComboboxControlPtr	_combobox;		// select product sub-categories
	SFREditboxControlPtr	_textcontrol;	// input keyword input
    SFRButtonControlPtr		_button;		// search button	

	SFXAnsiString       _errmsg;            // error message  
	SGRErrorDialogSet	_errorDialog;
    SGRSOAPDialogSet	_soapDialog;
	

public:
    SearchPane(SFRTabControlPtr tab, SFXWideStringConstRef title, SFXWideStringConstRef searchindex);
    virtual ~SearchPane(Void);

	HANDLER_DECLARE_BOOLEVENT(OnKey)
	HANDLER_DECLARE_VOIDEVENT(OnSoftkey)
	HANDLER_DECLARE_VOIDCONTROL(OnTextControl)
	HANDLER_DECLARE_VOIDCONTROL(OnButtonControl)

	static Void OnNetworkEntry(SGRSOAPDialogSet::NotifyEnum notify, SFCError error, VoidPtr reference);
    Void OnNetwork(SGRSOAPDialogSet::NotifyEnum notify, SFCError error);
	
	SFXAnsiString		 GetErrMsg(){return _errmsg;};	
	SFCError GetBrowseNodes(Void);
	SFCError ParseXML(Void);

private:
	SFCError AddComponents(Void);

};

// Search Window
SFMTYPEDEFCLASS(SearchWindow)
class SearchWindow : public SFRPlainWindow {
    SFMSEALCOPY(SearchWindow)
private:
       
	SFRTabControlPtr _tab;

public:
    SearchWindow(Void) static_throws;
    virtual ~SearchWindow(Void);
	
	HANDLER_DECLARE_VOIDVOID(TabSelect)
};

#endif  // __SEARCHWINDOW_HPP //
