//
//      pself3.cpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.1.
//

#include "pself3.hpp"
#include "SearchWindow.hpp"
#include "SGRSoftkeyWindow.hpp"
#include "SGRSoftkeyToolbox.hpp"

// Boot Loader
SFCApplet::FactorySPP SFCApplet::Boot(AEECLSID id, SFXAnsiStringPtr license)
{
    *license = "heap://"
        "Z7VFU0YEKXPTHKZ7W8Y6YQV8RBXQXEW2W6X0WIVOX9UJW1UEZCSFWBVFW8Y7GY2U2UHYIW6R9VMTMRNR"
        "DX3OZ7YBSCT0IX8Z7VNUAZAYEXKV2UKV5XMSKUGTCT8S5U5W2UNVOUGXMV46RQXAZARBVQWNRDY9RAV4"
        "VLXPT3VN03W7X9XBXHREUCRA6W3W9Z1Z7YMW4Y4YQWDV3VLT3UGXJS8TAXE61UDSEZ9Y3SHYJZ4Y8UFU"
        "BW5YAYJZ3T7VMBY3SFRDV0Z6V24V1T1RHZ3S6TFKWJSHYNBXGPSCW4U0ZAUG9REYDZ8W6YPF4Z9GKX4W"
        "4YMSGY9X0W33W9RLVGVAU9T2W9ZBX0JIRCFTPRJ"
    "/";

    return (id == AEECLSID_PSELF3) ? (&pself3::Factory) : (null);
}


// Factory function
SFCInvokerPtr pself3::Factory(Void)
{
    return ::new pself3;
}


// Constructor
pself3::pself3(Void) static_throws
{
	Bool b;
    SFRWindowPtr window;

    if (static_try()) {
        // register key handler (not accept key input)
        static_throw(RegisterHandler(SFEVT_KEY, HANDLER_AFTER, HANDLER_NULL));
        if (static_try()) {
			SFXDirectory::Exists(SFXPath(DIR_NAME), &b);
            if (!b) {
                SFXDirectory::Create(SFXPath(DIR_NAME));
            }

			if ((window = ::new SGRSoftkeyWindow(this)) != null) {
                static_throw(*window);
                if (static_try()) {
					// get base Amazon URL to send request
					GetURLLocaleFromFile(); 
					// create Search Window
					if ((window = ::new SearchWindow()) != null) {
                        static_throw(*window);
                    }
                    else {
                        static_throw(SFERR_NO_MEMORY);
                    }
                }
            }
            else
                static_throw(SFERR_NO_MEMORY);
        }
    }
}


// Destructor
pself3::~pself3(Void)
{
	_locale.Clear();
    return;
}

//Get Amazon locale url from xml file
SFCError pself3::GetURLLocaleFromFile()
{
	SFCError error(SFERR_NO_ERROR);
    SFXXMLDOMParser parser;
    parser.SetDoNamespaces(false);
	SFXXMLNodePtr _anode;

    error = parser.Parse(BROWSENODE_FILE); // parse XML file
	if (error != SFERR_NO_ERROR)
		return error;

    SFXXMLDocumentPtr root = parser.GetDocument(); // get the root
    
	// if parsing failed
	if (root==null)
		return SFERR_FAILED;

    // Get locale
    SFXList<SFXXMLNodePtr>* list = root->GetElementsByTagName("Locale");
	
	if (list == null || list->GetSize() == 0)
	{
		_locale = "amazon.co.jp"; 
		return SFERR_NO_ERROR;
    }

	_anode = list->Get(0); 
	_locale = SFXAnsiString(_anode->GetText());
		
return error;
}
